unit GLToolsDelphi;                                      // Version 12.12.04 //
                                       // Dreiecksnetz mit Texturkoordinaten //
interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     ExtCtrls, ComCtrls, StdCtrls, Menus, Math, Jpeg, OpenGL12; 

type
  PPixelArray = ^TPixelArray;
  TPixelArray = array [0..0] of Byte;

  point = record
            x, y, z : GLfloat;
          end;

  TRectangle = record
                 Left, Top, Width, Height: GLint;
               end;

  TSprite = record
              Width,Height: GLfloat;
              Texture:      String[255];
              Index:        cardinal;
            end;

procedure DrawSprite(Sprite: TSprite; CamX,CamY,CamZ: GLFloat; Rot: Boolean);

const TexturWidth =64; TexturHeight=64;
      TexB=32;         TexH=32;
      Vierecke=1;      Dreiecke=2;       Viereck=3;
      Kugel=1;

type  Farben3= record R,G,B: GLubyte end;
      Farben4= record R,G,B,A: GLfloat end;
      TSurface=procedure(s,t: GLfloat; Param: array of GLfloat; var x,y,z: GLfloat);
      PktXY100 = array [1..100] of record x,y: double; end; {Liste der Punkte zur Berechnung}
      TP16  = array [0..15] of record x,y,z,w: GLfloat end;

var   AlfaTextur:   GLfloat=0;
      Textur0:  array [1..TexturWidth,1..TexturHeight] of Farben3;
      Textur1,Textur2,Textur3: array [1..TexB,1..TexH] of Farben4;
      MipMap32: array [1..32,1..32,1..3] of GLubyte;
      MipMap16: array [1..16,1..16,1..3] of GLubyte;
      MipMap8:  array [1.. 8,1.. 8,1..3] of GLubyte;
      MipMap4:  array [1.. 4,1.. 4,1..3] of GLubyte;
      MipMap2:  array [1.. 2,1.. 2,1..3] of GLubyte;
      MipMap1:  array [1.. 1,1.. 1,1..3] of GLubyte;

const  MusterBiene:  array [0..127] of gluByte =
       ($00,$00,$00,$00,$00,$00,$00,$00,
        $03,$80,$01,$C0,$06,$C0,$03,$60,
        $04,$60,$06,$20,$04,$30,$0C,$20,
        $04,$18,$18,$20,$04,$0C,$30,$20,
        $04,$06,$60,$20,$44,$03,$C0,$22,
        $44,$01,$80,$22,$44,$01,$80,$22,
        $44,$01,$80,$22,$44,$01,$80,$22,
        $44,$01,$80,$22,$44,$01,$80,$22,
        $66,$01,$80,$66,$33,$01,$80,$CC,
        $19,$81,$81,$98,$0C,$C1,$83,$30,
        $07,$E1,$87,$E0,$03,$3F,$FC,$C0,
        $03,$31,$8C,$C0,$03,$33,$CC,$C0,
        $06,$64,$26,$60,$0C,$CC,$33,$30,
        $18,$CC,$33,$18,$10,$C4,$23,$08,
        $10,$63,$C6,$08,$10,$30,$0C,$08,
        $10,$18,$18,$08,$10,$00,$00,$08);

  const Muster1:  array [0..127] of GLubyte =
       ($A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0);

        Muster2:  array [0..127] of gluByte =
       ($AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,
        $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0);

        Muster3:  array [0..127] of gluByte =
       ($00,$00,$00,$00,$00,$00,$00,$00,
        $03,$80,$01,$C0,$06,$C0,$03,$60,
        $04,$60,$06,$20,$04,$30,$0C,$20,
        $04,$18,$18,$20,$04,$0C,$30,$20,
        $04,$06,$60,$20,$44,$03,$C0,$22,
        $44,$01,$80,$22,$44,$01,$80,$22,
        $44,$01,$80,$22,$44,$01,$80,$22,
        $44,$01,$80,$22,$44,$01,$80,$22,
        $66,$01,$80,$66,$33,$01,$80,$CC,
        $19,$81,$81,$98,$0C,$C1,$83,$30,
        $07,$E1,$87,$E0,$03,$3F,$FC,$C0,
        $03,$31,$8C,$C0,$03,$33,$CC,$C0,
        $06,$64,$26,$60,$0C,$CC,$33,$30,
        $18,$CC,$33,$18,$10,$C4,$23,$08,
        $10,$63,$C6,$08,$10,$30,$0C,$08,
        $10,$18,$18,$08,$10,$00,$00,$08);

  procedure CreateTextur0(Art: GLint);
  procedure CreateTextur1(AlfaTextur: GLfloat); // Quadrat-Textur
  procedure CreateTextur2(AlfaTextur: GLfloat); // Biene-Textur
  procedure CreateTextur3(AlfaTextur: GLfloat); // Random-Textur
  procedure SetTextur3;  // Setzen der Random-Textur
  procedure LoadMipmaps; // Gesetzte Mipmaps
  procedure Quader(x0,y0,z0,lx,ly,lz: GLfloat; Art: GLenum);
  procedure Kirche(Art: GLenum);
  procedure FarbWuerfel(h: GLfloat);
  procedure Koordinatenachsen(x,y,z,width: GLfloat);
  procedure Dreiecksnetz(ns,nt: GLuint; Param: array of GLfloat; Surface: TSurface);
  procedure KubischesSpline(AnzKP: integer; KP: TP16; var KubSpline: PktXY100);

//  neu: Dezember 2002
procedure CreateText2D(DC:hdc; ListBase: GLint; Schrift: PChar; Size: GLint);
procedure OutText2D(DC:hdc; ListBase: GLint; x,y: GLdouble; AusgabeText: PChar);
procedure CreateText3D(DC:hdc; ListBase: GLint; Schrift: PChar; Tiefe: GLfloat);
procedure OutText3D(DC:hdc; ListBase: GLint; AusgabeText: PChar);
procedure CreateImageBMP(BitmapName: string;
                         var ImageWidth,ImageHeight: GLint; var PBMP: pointer);
procedure CreateImageJPG(Texture: String;
                         var ImageWidth,ImageHeight: GLint; var PJPG: Pointer);
//  neu: Dezember 2002




implementation

//uses MMSystem;

procedure KubischesSpline(AnzKP: integer; KP: TP16; var KubSpline: PktXY100);
  type Vektor100  = array [1..100] of real;   {Zwischenwerte bei Splines}
  var xpkt,ypkt,t,ax,bx,cx,ay,by,cy: Vektor100;	{Spline-Koeffizienten}
      PktAnz,i,j:                    integer;	{Zhlvariablen}
      h,wt,dt:                       double;	{Hilfsvariablen}
      P:                             PktXY100;

  {*** Parametrisierung der Kubischen Spline **********************}
  procedure Parametrisierung(x,y: Vektor100; n : integer;
                             var t: Vektor100);
    var i:         byte;
        dx,dy,max: real;
  begin
    t[1]:=0;
    for i:=1 to n-1 do
    begin
      dx:=abs(x[i+1]-x[i]);  dy:=abs(y[i+1]-y[i]);
      if dx>dy then max:=dx else max:=dy;
      t[i+1]:=t[i]+(dx+dy+2*max)/3
    end;
  end {Parametrisierung};

  {*** Ermittlung der Koeffizienten der Berechnungsmatrix *********}
  procedure Spline_Koeffizienten(f,t: Vektor100; n: integer;
                                 var a,b,c: Vektor100);
    var dt,D,m,k:  Vektor100;			{Hilfsfelder und}
        bh,dh,e,h: double;			{Hilfsvariablen}
        i:         integer;			{Zhlvariable}
  begin
    for i:=2 to n do
    begin
      dt[i]:=t[i]-t[i-1];
      if dt[i]=0 then dt[i]:=1;
      D[i]:=(f[i]-f[i-1])/dt[i]
    end;
    m[ 1]:=dt[3];				{erstes Intervall}
    dt[1]:=t[3]-t[1];
    if dt[1]=0 then dt[1]:=1;
    h:=dt[2];
    k[1]:=((h+2*dt[1])*D[2]*dt[3]+sqr(h)*D[3])/dt[1];
    for i:=2 to n-1 do			{weitere Intervalle}
    begin
      h:=-dt[i+1]/m[i-1];
      k[i]:=h*k[i-1]+3*(dt[i]*D[i+1]+dt[i+1]*D[i]);
     m[i]:=h*dt[i-1]+2*(dt[i]+dt[i+1])
    end;
    h:=t[n]-t[n-2];				{letztes Intervall}
    dh:=dt[n];
    k[n]:=((dh+h+h)*D[n]*dt[n-1]+sqr(dh)*D[n-1])/h;
    h:=-h/m[n-1];
    m[n]:=(h+1)*dt[n-1];
    a[n]:=(h*k[n-1]+k[n])/m[n];
    for i:=n-1 downto 1 do a[i]:=(k[i]-dt[i]*a[i+1])/m[i];
    for i:=2 to n do
    begin		{Generierung der Koeffizienten}
      dh:=D[i]; bh:=dt[i];
      e:=a[i-1]+a[i]-dh-dh;
      b[i-1]:=(dh-a[i-1]-e)/bh;
      c[i-1]:=e/sqr(bh);
    end;
  end {Spline_Koeffizienten};
begin
  PktAnz:= AnzKP;
//  for j:=1 to PktAnz do
  for j:=1 to PktAnz do
  begin P[j].x:=KP[j-1].x;   P[j].y:=KP[j-1].y; end;
//  for i:=1 to PktAnz do
  for i:=1 to PktAnz do
  begin xpkt[i]:=P[i].x; ypkt[i]:=P[i].y; end;
  Parametrisierung(xpkt,ypkt,PktAnz,t);
  Spline_Koeffizienten(xpkt,t,PktAnz,ax,bx,cx);
  Spline_Koeffizienten(ypkt,t,PktAnz,ay,by,cy);
  wt:=0; i:=1;
  dt:=t[PktAnz]/99;
  t[PktAnz]:=t[PktAnz]+1.0;
  for j:=1 to 100 do
  begin
    while wt > t[i+1] do inc(i);
    h:=wt-t[i];
    KubSpline[j].x:=xpkt[i]+h*(ax[i]+h*(bx[i]+h*cx[i]));
    KubSpline[j].y:=ypkt[i]+h*(ay[i]+h*(by[i]+h*cy[i]));
    wt:=wt+dt;
  end;
  t[PktAnz]:=t[PktAnz]-1.0;
end {KubischesSpline};

procedure DrawSprite(Sprite: TSprite; CamX,CamY,CamZ: GLfloat; Rot: Boolean);
begin
  with Sprite do
  begin
    glbindtexture(Gl_Texture_2D,Index);
    If rot then
    begin
      glPushMatrix;
        glrotatef(90,0,1,0);
        glrotatef(radtodeg(arctan(camz/camy)),0,0,1);
        glPushMatrix;
          glrotatef(radtodeg(arctan(camx/camy))+90,1,0,0);
          glBegin (GL_QUADS);
            glTexCoord2f(0.0,0.0);  glVertex3f(Height,Width,0);
            glTexCoord2f(0.0,1.0);  glVertex3f(-Height,Width,0);
            glTexCoord2f(1.0,1.0);  glVertex3f(-Height,-Width,0);
            glTexCoord2f(1.0,0.0);  glVertex3f(Height,-Width,0);
          glEnd;
        glPopMatrix;
      glPopMatrix;
    end
    else
    begin
      glPushMatrix;
        glrotatef(90,0,1,0);
        glBegin (GL_QUADS);
          glTexCoord2f(0.0,0.0);  glVertex3f(Height,Width,0);
          glTexCoord2f(0.0,1.0);  glVertex3f(-Height,Width,0);
          glTexCoord2f(1.0,1.0);  glVertex3f(-Height,-Width,0);
          glTexCoord2f(1.0,0.0);  glVertex3f(Height,-Width,0);
        glEnd;
      glPopMatrix;
    end;
  end;
end;

procedure CreateTextur0(Art: GLint);
  var i,j,k: GLubyte;
  procedure Muster1(ia,ie,ja,je: GLubyte);
    var i,j: GLubyte;
  begin
       for i:=ia to ie do
       for j:=ja to je do
       with Textur0[i,j]do begin R:=255; G:=255; B:=255; end;
  end;
  procedure Muster2(ia,ie,ja,je: glUByte);
    var i,j: glUByte;
  begin
       for i:=ia to ie do
       for j:=ja to je do
       with Textur0[i,j]do begin R:=15*(i-ia); G:=0; B:=15*(j-ja); end;
  end;
begin
glDisable(GL_LIGHTING);
  case Art of
  1: begin
       for i:=1 to 64 do
       for j:=1 to 64 do
       with Textur0[i,j]do begin R:=0; G:=0; B:=0; end;
       Muster1( 1,16, 1,16); Muster1( 1,16,33,48);
       Muster1(17,32,17,32); Muster1(17,32,49,64);
       Muster1(33,48, 1,16); Muster1(33,48,33,48);
       Muster1(49,64,17,32); Muster1(49,64,49,64);
     end {1};
  2,3: begin
         for i:=1 to 64 do
         for j:=1 to 64 do
         with Textur0[i,j]do
         begin k:=255*round(cos(sqr(i-32)+sqr(j-32))); R:=abs(k); G:=100; B:=0; end;
     end {2,3};
   end {case};

  glPixelStorei(GL_UNPACK_ALIGNMENT,1);
  glTexImage2D(GL_TEXTURE_2D,0,3,TexturWidth,TexturHeight,0,
               GL_RGB,GL_UNSIGNED_BYTE,@Textur0);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
//  glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
  glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
  glEnable(GL_TEXTURE_2D);
//  glShadeModel(GL_FLAT);
//  glEnable(GL_LIGHT0);
end {CreateTextur0};

procedure CreateTextur1(AlfaTextur: GLfloat);
  var i,j: glByte;
begin
  for i:=1 to TexB div 2 do
  for j:=1 to TexH div 2 do
  with Textur1[i,j] do begin R:=0; G:=0; B:=1; A:=AlfaTextur end;
  for i:=TexB div 2+1  to TexB do
  for j:=TexH div 2+1 to TexH do
  with Textur1[i,j] do begin R:=1; G:=0; B:=0; A:=AlfaTextur end;
  for i:=TexB div 2+1 to TexB do
  for j:=1 to TexH div 2 do
  with Textur1[i,j] do begin R:=0; G:=1; B:=0; A:=AlfaTextur end;
  for i:=1 to TexB div 2 do
  for j:=TexH div 2+1 to TexH do
  with Textur1[i,j] do begin R:=1; G:=1; B:=1; A:=AlfaTextur end;
end {CreateTextur1};

procedure CreateTextur2(AlfaTextur: GLfloat);
  var i,j: glByte;
  procedure SetPoints(Zeile,Spalte,AnzahlSpalten: gluByte);
    var s: gluByte;
  begin
    for s:=0 to AnzahlSpalten-1 do
    begin
      with Textur2[Zeile,Spalte+s] do begin R:=1; G:=0; B:=0; A:=AlfaTextur end;
      Textur2[Zeile,TexB-Spalte-s+1]:=Textur2[Zeile,Spalte+s]
    end;
  end {SetPoints};
begin
  for i:=1 to TexB do
  for j:=1 to TexH do
  with Textur2[i,j] do begin R:=1; G:=1; B:=1; A:=AlfaTextur end;
  SetPoints( 3,7,3);
  SetPoints( 4,6,2); SetPoints( 4,9,2);
  SetPoints( 5,6,1); SetPoints( 5,10,2);
  SetPoints( 6,6,1); SetPoints( 6,11,2);
  SetPoints( 7,6,1); SetPoints( 7,12,2);
  SetPoints( 8,6,1); SetPoints( 8,13,2);
  SetPoints( 9,6,1); SetPoints( 9,14,2);
  SetPoints(10,2,1); SetPoints(10,6,1); SetPoints(10,15,2);
  SetPoints(11,2,1); SetPoints(11,6,1); SetPoints(11,16,1);
  SetPoints(12,2,1); SetPoints(12,6,1); SetPoints(12,16,1);
  SetPoints(13,2,1); SetPoints(13,6,1); SetPoints(13,16,1);
  SetPoints(14,2,1); SetPoints(14,6,1); SetPoints(14,16,1);
  SetPoints(15,2,1); SetPoints(15,6,1); SetPoints(15,16,1);
  SetPoints(16,2,1); SetPoints(16,6,1); SetPoints(16,16,1);
  SetPoints(17,2,2); SetPoints(17,6,2); SetPoints(17,16,1);
  SetPoints(18,3,2); SetPoints(18,7,2); SetPoints(18,16,1);
  SetPoints(19,4,2); SetPoints(19,8,2); SetPoints(19,16,1);
  SetPoints(20,5,2); SetPoints(20,9,2); SetPoints(20,16,1);
  SetPoints(21,6,6); SetPoints(21,16,1);
  SetPoints(22,7,2); SetPoints(22,11,6);
  SetPoints(23,7,2); SetPoints(23,11,2); SetPoints(23,16,1);
  SetPoints(24,7,2); SetPoints(24,11,2); SetPoints(24,15,2);
  SetPoints(25,6,2); SetPoints(25,10,2); SetPoints(25,14,1);
  SetPoints(26,5,2); SetPoints(26, 9,2); SetPoints(26,13,2);
  SetPoints(27,4,2); SetPoints(27, 9,2); SetPoints(27,13,2);
  SetPoints(28,4,1); SetPoints(28, 9,2); SetPoints(28,14,1);
  SetPoints(29,4,1); SetPoints(29,10,2); SetPoints(29,15,2);
  SetPoints(30,4,1); SetPoints(30,11,2);
  SetPoints(31,4,1); SetPoints(31,12,2);
end {CreateTextur2};

procedure CreateTextur3(AlfaTextur: GLfloat);
  var   k,i:       glint;
begin
  for i:=1 to TexB do
  for k:=1 to TexH do
    with Textur3[i,k] do
    begin {R:=Random; G:=Random; B:=Random;} A:=AlfaTextur end;
end {CreateTextur3};

procedure SetTextur3;
  var   k,i:       glint;
begin
  for i:=1 to TexB do
  for k:=1 to TexH do
    with Textur3[i,k] do
    begin R:=Random; G:=Random; B:=Random; A:=AlfaTextur end;
end {CreateTextur3};

procedure LoadMipMaps;
  var i,j: gluByte;
BEGIN
  for i:=1 to 32 do
  for j:=1 to 32 do
  begin MipMap32[i,j,1]:=  0; MipMap32[i,j,2]:=  0; MipMap32[i,j,3]:=255; end;
  for i:=1 to 16 do
  for j:=1 to 16 do
  begin MipMap16[i,j,1]:=255; MipMap16[i,j,2]:=  0; MipMap16[i,j,3]:=255; end;
  for i:=1 to 8 do
  for j:=1 to 8 do
  begin MipMap8[i,j,1] :=255; MipMap8[i,j,2] :=  0; MipMap8[i,j,3] :=  0; end;
  for i:=1 to 4 do
  for j:=1 to 4 do
  begin MipMap4[i,j,1] :=  0; MipMap4[i,j,2] :=255; MipMap4[i,j,3] :=  0; end;
  for i:=1 to 2 do
  for j:=1 to 2 do
  begin MipMap2[i,j,1] :=175; MipMap2[i,j,2] :=175; MipMap2[i,j,3] :=  0; end;
        MipMap1[1,1,1] :=  0; MipMap1[1,1,2] :=  0; MipMap1[1,1,3] :=  0;
end; // LoadMipMaps

var lxSchiff,lySchiff,lzSchiff,hDach,bTurm,hTurm,hSpitze: GLfloat;

procedure Quader(x0,y0,z0,lx,ly,lz: GLfloat; Art: GLenum);
  type  Points3D= record x,y,z: glFloat end;
  var   P1,P2,P3,P4,P5,P6,P7,P8: Points3D;
        xneg,xpos,yneg,ypos,zneg,zpos: GLfloat;
begin
  xneg:=x0-0.5*lx;  xpos:=xneg+lx;
  yneg:=y0-0.5*ly;  ypos:=yneg+ly;
  zneg:=z0;         zpos:=zneg+lz;
  P1.x:=xpos; P1.y:=yneg; P1.z:=zpos;
  P2.x:=xpos; P2.y:=ypos; P2.z:=zpos;
  P3.x:=xneg; P3.y:=ypos; P3.z:=zpos;
  P4.x:=xneg; P4.y:=yneg; P4.z:=zpos;
  P5.x:=xpos; P5.y:=yneg; P5.z:=zneg;
  P6.x:=xpos; P6.y:=ypos; P6.z:=zneg;
  P7.x:=xneg; P7.y:=ypos; P7.z:=zneg;
  P8.x:=xneg; P8.y:=yneg; P8.z:=zneg;

  glBegin(Art);
    glNormal3f(0,0,1);
    glVertex3fv(@P1); glVertex3fv(@P2); glVertex3fv(@P3); glVertex3fv(@P4);
  glEnd;
  glBegin(Art);
    glNormal3f(0,0,-1);
    glVertex3fv(@P6); glVertex3fv(@P5); glVertex3fv(@P8); glVertex3fv(@P7);
  glEnd;
  glBegin(Art);
    glNormal3f(-1,0,0);
    glVertex3fv(@P7); glVertex3fv(@P8); glVertex3fv(@P4); glVertex3fv(@P3);
  glEnd;
  glBegin(Art);
    glNormal3f(1,0,0);
    glVertex3fv(@P1); glVertex3fv(@P5); glVertex3fv(@P6); glVertex3fv(@P2);
  glEnd;
  glBegin(Art);
    glNormal3f(0,1,0);
    glVertex3fv(@P2); glVertex3fv(@P6); glVertex3fv(@P7); glVertex3fv(@P3);
  glEnd;
  glBegin(Art);
    glNormal3f(0,-1,0);
    glVertex3fv(@P1); glVertex3fv(@P4); glVertex3fv(@P8); glVertex3fv(@P5);
  glEnd;
end; {Quader}

procedure Dach(x0,y0,z0,lx,ly,hz,dxl,dxr,dy: GLfloat; Art: GLenum);
  type  Points3D= record x,y,z: glFloat end;
  var   P1,P2,P3,P4,P5,P6: Points3D;
        xneg,xpos,yneg,ypos,zneg,zpos: GLfloat;
begin
  xneg:=x0-0.5*lx;  xpos:=xneg+lx;
  yneg:=y0-0.5*ly;  ypos:=yneg+ly;
  zneg:=z0;         zpos:=zneg+hz;
  P1.x:=xpos;     P1.y:=yneg;  P1.z:=zneg;
  P2.x:=xneg;     P2.y:=yneg;  P2.z:=zneg;
  P3.x:=xneg;     P3.y:=ypos;  P3.z:=zneg;
  P4.x:=xpos;     P4.y:=ypos;  P4.z:=zneg;
  P5.x:=xneg+dxl; P5.y:=y0+dy; P5.z:=zpos;
  P6.x:=xpos-dxr; P6.y:=y0+dy; P6.z:=zpos;

  glBegin(Art);  // Dachgrundflche
    glNormal3f(0,0,-1);
    glVertex3fv(@P1); glVertex3fv(@P2); glVertex3fv(@P3); glVertex3fv(@P4);
  glEnd;
  glBegin(Art);  // linke Dachflche
    glNormal3f(-1,0,0);
    glVertex3fv(@P2); glVertex3fv(@P5); glVertex3fv(@P3);
  glEnd;
  glBegin(Art);  // rechte Dachflche
    glNormal3f(1,0,0);
    glVertex3fv(@P1); glVertex3fv(@P4); glVertex3fv(@P6);
  glEnd;
  glBegin(Art);  // untere Dachflche
    glNormal3f(0,-1,0);
    glVertex3fv(@P1); glVertex3fv(@P6); glVertex3fv(@P5); glVertex3fv(@P2);
  glEnd;
  glBegin(Art);  // obere Dachflche
    glNormal3f(0,1,0);
    glVertex3fv(@P6); glVertex3fv(@P4); glVertex3fv(@P3); glVertex3fv(@P5);
  glEnd;
end; {Dach}

const ColorH:        array [0..3] of GLfloat=(0.6,0.6,0.6,1.0);
      Rot:           array [0..3] of GLfloat=(1,0.3,0.3,1);

procedure Kirche(Art: GLenum);
begin
  glRotatef(-90,1,0,0);
  lxSchiff:=15; lySchiff:=6; lzSchiff:=6; hDach:=5;
  bTurm:=2; hTurm:=8; hSpitze:=4;
  glColor3fv(@ColorH);
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,@ColorH);
  Quader(0,0,0,lxSchiff,lySchiff,lzSchiff,Art);
  Quader(-0.5*(lxSchiff-bTurm),-0.5*(lySchiff-bTurm),0,bTurm+0.5,bTurm+0.5,hTurm,Art);
  Quader(-0.5*(lxSchiff-bTurm), 0.5*(lySchiff-bTurm),0,bTurm+0.5,bTurm+0.5,hTurm,Art);
  glColor3fv(@Rot);
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,@Rot);
  Dach(0,0,lzSchiff,lxSchiff,lySchiff,hDach,3,3,0,Art);
  Dach(-0.5*(lxSchiff-bTurm),-0.5*(lySchiff-bTurm),hTurm,bTurm+0.5,bTurm+0.5,hTurm+hSpitze,
                                                   0.5*bTurm+0.25,0.5*bTurm+0.25,0,Art);
  Dach(-0.5*(lxSchiff-bTurm), 0.5*(lySchiff-bTurm),hTurm,bTurm+0.5,bTurm+0.5,hTurm+hSpitze,
                                                   0.5*bTurm+0.25,0.5*bTurm+0.25,0,Art);
end;

procedure FarbWuerfel(h: GLfloat);
begin
    glBegin(GL_POLYGON);    // Unterseite Magenta
      glColor3f(1,0,1);       glNormal3f(0,-1,0);
      glVertex3f(-h,-h, h);   glVertex3f( h,-h, h);
      glVertex3f( h,-h,-h);   glVertex3f(-h,-h,-h);
    glEnd;
    glBegin(GL_POLYGON);    // Oberseite Cyan
      glColor3f(0,1,1);       glNormal3f(0,1,0);
      glVertex3f(-h, h, h);   glVertex3f(-h, h,-h);
      glVertex3f( h, h,-h);   glVertex3f( h, h, h);
    glEnd;
    glBegin(GL_POLYGON);    // Vorderseite Rot
      glColor3f(1,0,0);       glNormal3f(0,0,1);
      glVertex3f(-h,-h, h);   glVertex3f(-h, h, h);
      glVertex3f( h, h, h);   glVertex3f( h,-h, h);
    glEnd;
    glBegin(GL_POLYGON);    // Hinterseite Blau
      glColor3f(0,0,1);       glNormal3f(0,0,-1);
      glVertex3f( h,-h,-h);   glVertex3f( h, h,-h);
      glVertex3f(-h, h,-h);   glVertex3f(-h,-h,-h);
    glEnd;
    glBegin(GL_POLYGON);    // Linke Seite Grn
      glColor3f(0,1,0);       glNormal3f(-1,0,0);
      glVertex3f(-h,-h,-h);   glVertex3f(-h, h,-h);
      glVertex3f(-h, h, h);   glVertex3f(-h,-h, h);
    glEnd;
    glBegin(GL_POLYGON);    // Rechte Seite Gelb
      glColor3f(1,1,0);       glNormal3f(1,0,0);
      glVertex3f( h,-h, h);   glVertex3f( h, h, h);
      glVertex3f( h, h,-h);   glVertex3f( h,-h,-h);
    glEnd;
  glEndList;
end {Farbwuerfel};

procedure Koordinatenachsen(x,y,z,width: GLfloat);
  var Licht: GLboolean;  Breite: GLfloat;
begin
  glGetFloatv(GL_LINE_WIDTH,@Breite);
  glLineWidth(width);
  Licht:=glIsEnabled(GL_LIGHTING);
  if Licht then glDisable(GL_LIGHTING);
  glBegin(GL_LINES);
    glColor3f(1,0,0); glVertex3f(0,0,0);  glVertex3f(x,0,0);
    glColor3f(0,1,0); glVertex3f(0,0,0);  glVertex3f(0,y,0);
    glColor3f(0,0,1); glVertex3f(0,0,0);  glVertex3f(0,0,z);
  glEnd;
  glBegin(GL_TRIANGLE_FAN);
  glEnd;
  if Licht then glEnable(GL_LIGHTING);
  glLineWidth(Breite);
end;

procedure Dreiecksnetz(ns,nt: GLuint; Param: array of GLfloat; Surface: TSurface);
  type P=         record x,y,z: GLfloat end;
       PTex=      record x,y: GLfloat end;
  var  i,j,k:     GLbyte;
       x21,y21,z21,x31,y31,z31,s,t: GLfloat;
       F,N:       array [0..100,0..100] of P;
       Tex:       array [0..100,0..100] of PTex;
begin

//  Berechnung der Oberflchenpunkte
  if ns>100 then ns:=100;
  if nt>100 then nt:=100;
  for i:=0 to ns do
  begin
    for j:=0 to nt do
    with F[i,j] do
    begin
      s:=i/ns; t:=j/nt; Surface(s,t,Param,x,y,z);
    end
  end;
//(*
//  Berechnung der Texturkoordinaten
  for i:=0 to ns do
  begin
    for j:=0 to nt do
    with Tex[i,j] do
    begin
      x:=i/ns; y:=j/nt; //Surface(s,t,Param,x,y,z);
    end
  end;
//*)
// Berechnung der Normalen
  for i:=0 to ns-1 do
  for j:=0 to nt-1 do
  with F[i,j] do
  begin
    x21:=F[i+1,j].x-x; y21:=F[i+1,j].y-y; z21:=F[i+1,j].z-z;
    x31:=F[i,j+1].x-x; y31:=F[i,j+1].y-y; z31:=F[i,j+1].z-z;
    with N[i,j] do
    begin x:=y21*z31-y31*z21; y:=z21*x31-z31*x21; z:=x21*y31-x31*y21; end;
  end;
  for j:=0 to nt-1 do
  with F[ns,j] do
  begin
    x21:=F[ns,j+1].x-x; y21:=F[ns,j+1].y-y; z21:=F[ns,j+1].z-z;
    x31:=F[ns-1,j].x-x; y31:=F[ns-1,j].y-y; z31:=F[ns-1,j].z-z;
    with N[ns,j] do
    begin x:=y21*z31-y31*z21; y:=z21*x31-z31*x21; z:=x21*y31-x31*y21; end;
  end;
  for i:=0 to ns-1 do
  with F[i,nt] do
  begin
    x21:=F[i,nt-1].x-x; y21:=F[i,nt-1].y-y; z21:=F[i,nt-1].z-z;
    x31:=F[i+1,nt].x-x; y31:=F[i+1,nt].y-y; z31:=F[i+1,nt].z-z;
    with N[i,nt] do
    begin x:=y21*z31-y31*z21; y:=z21*x31-z31*x21; z:=x21*y31-x31*y21; end;
  end;
  with F[ns,nt] do
  begin
    x21:=F[ns-1,nt].x-x; y21:=F[ns-1,nt].y-y; z21:=F[ns-1,nt].z-z;
    x31:=F[ns,nt-1].x-x; y31:=F[ns,nt-1].y-y; z31:=F[ns,nt-1].z-z;
    with N[ns,nt] do
    begin x:=y21*z31-y31*z21; y:=z21*x31-z31*x21; z:=x21*y31-x31*y21; end;
  end;

// Zeichnen der Oberflche
  for i:=0 to ns-1 do
  begin
    k:=i+1;
    glBegin(GL_TRIANGLE_STRIP);
      for j:=0 to nt do
      begin
        glNormal3fv(@N[i,j]); glTexCoord2fv(@Tex[i,j]); glVertex3fv(@F[i,j]);
        glNormal3fv(@N[k,j]); glTexCoord2fv(@Tex[k,j]); glVertex3fv(@F[k,j]);
      end;
    glEnd;
  end;
end {Dreiecksnetz};



//   *** neu: Dezember 2002 ***
procedure CreateText2D(DC: hdc; ListBase: GLint; Schrift: PChar; Size: GLint);
  var   LogicFont: TLOGFONT;
        hOldFont,hNewFont: HFONT;
begin
  FillChar(LogicFont, SizeOf(LogicFont), 0);
  LogicFont.lfHeight               := -Size;
  lstrcpy (LogicFont.lfFaceName, Schrift) ;
  hNewFont := CreateFontIndirect(LogicFont);
  hOldFont := SelectObject(DC,hNewFont);
  wglUseFontBitmaps(DC,0,256,ListBase);
  DeleteObject(SelectObject(DC,hOldFont));
  DeleteObject(SelectObject(DC,hNewFont));
end {CreateText2D};

procedure OutText2D(DC:hdc; ListBase: GLint; x,y: GLdouble; AusgabeText: PChar);
  var Licht,Blending: GLboolean;
begin
  Blending:=glIsEnabled(GL_BLEND);
  Licht:=glIsEnabled(GL_LIGHTING);
  if Blending then glDisable(GL_BLEND);
  if Licht then glDisable(GL_LIGHTING);
  glListBase(ListBase);
  glRasterPos2f(x,y);
  glCallLists(Length(AusgabeText),GL_UNSIGNED_BYTE,AusgabeText);
  if Blending then glEnable(GL_BLEND);
  if Licht then glEnable(GL_LIGHTING);
end {OutText2D};

procedure CreateText3D(DC:hdc; ListBase: GLint; Schrift: PChar; Tiefe: GLfloat);
  var   LogicFont: TLOGFONT;
        hOldFont,hNewFont: HFONT;
begin
  FillChar(LogicFont, SizeOf(LogicFont), 0);
  lstrcpy (LogicFont.lfFaceName, Schrift) ;
  hNewFont := CreateFontIndirect(LogicFont);
  hOldFont := SelectObject(DC,hNewFont);
  wglUseFontOutlines(DC,0,255,ListBase,0,Tiefe,WGL_FONT_POLYGONS,nil);
  DeleteObject(SelectObject(DC,hOldFont));
  DeleteObject(SelectObject(DC,hNewFont));
end {CreateText3D};

procedure OutText3D(DC: hdc; ListBase: GLint; AusgabeText: PChar);
begin
  glListBase(ListBase);
  glCallLists(Length(AusgabeText),GL_UNSIGNED_BYTE,AusgabeText);
end {OutText3D};

procedure CreateImageBMP(BitmapName: string;
                         var ImageWidth,ImageHeight: GLint; var PBMP: pointer);
  type TRGBRec= record R,G,B: byte end;
  var  i:       integer;
       a:       byte;
       BMPStream: TMemoryStream;
       DC:     THandle;
       Bitmap: TBitmap;
begin
  Bitmap:=TBitmap.Create;
  Bitmap.LoadFromFile(BitmapName);
  DC:=GetDC(0);
  BMPStream:=TMemoryStream.Create;
  with Bitmap do BMPStream.SetSize(SizeOf(TBitMapInfoHeader)+Height*Width*3);
  with TBitMapInfoHeader(BMPStream.Memory^) do
  begin
    biSize:=SizeOf(TBitMapInfoHeader);
    biWidth:=Bitmap.Width;
    biHeight:=Bitmap.Height;
    biPlanes:=1;
    biBitCount:=24;
    biCompression:=BI_RGB;
    biSizeImage:=0;
    biXPelsPerMeter:=0;//10000;
    biYPelsPerMeter:=0;//10000;
    biClrUsed:=0;
    biClrImportant:=0;
    ImageWidth:=biWidth;
    ImageHeight:=biHeight;
  end;
  PBMP:=Pointer(longint(BMPStream.Memory)+SizeOf(TBitmapInfoHeader));
  GetDIBits(DC,Bitmap.Handle,0,Bitmap.Height, PBMP,
            TBitMapInfo(BMPStream.Memory^),DIB_RGB_COLORS);
  for i:=0 to ImageWidth*ImageHeight-1 do
  with TRGBRec(Pointer(longint(PBMP)+i*3)^) do
  begin a:=R; R:=B; B:=a; end;
  Bitmap.Free;
end {CreateImageBMP};

procedure CreateImageJPG(Texture: String;
                         var ImageWidth,ImageHeight: GLint; var PJPG: Pointer);
  type PPixelArray = ^TPixelArray;
       TPixelArray = array [0..0] of Byte;
  var  Bitmap:      TBitmap;
       BMInfo:      TBitmapInfo;
       i,ImageSize: Integer;
       Temp:        Byte;
       DC:          HDC;
       Picture:     TJpegImage;
       Pixels:      PPixelArray;
begin
  Bitmap:=TBitMap.Create;
  Picture:=TJpegImage.Create;
  Picture.LoadFromFile(Texture);
  Bitmap.Assign(Picture);
  with BMinfo.bmiHeader do
  begin
    FillChar(BMInfo,SizeOf(BMInfo),0);
    biSize:= sizeof (TBitmapInfoHeader);
    biBitCount:= 24;
    biWidth:= Picture.Width;
    biHeight:= Picture.Height;
    biPlanes:= 1;
    biCompression:= BI_RGB;
    ImageWidth:=biWidth;
    ImageHeight:=biHeight;
    ImageSize:= biWidth*biHeight;
    DC:= CreateCompatibleDC(0);
    GetMem(Pixels,ImageSize*3);
    try
      GetDIBits (DC,Bitmap.Handle,0,biHeight,Pixels,BMInfo,DIB_RGB_COLORS);
      for i:=0 to ImageSize-1 do
      begin
        Temp:=Pixels[i*3];  Pixels[i*3]:=Pixels[i*3+2];  Pixels[i*3+2]:= Temp;
      end;
      PJPG:=Pixels;
    finally
      DeleteDC(DC);
      Bitmap.Free;
      Picture.Free;
    end;
  end;
end {CreateImageJPG};

end {GLToolsDelphiNeu}.



